// 002 u_c_genc_043_min_max_i_comparable
// 03 jan 2008

// -- (C) Felix John COLIBRI 2008
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_genc_043_min_max_i_comparable;
  interface
    uses System.Collections.Generic;

    type c_min_max=
             class
               class function f_min<T: IComparable<T> >(p_one, p_two: T): T; static;
               class function f_max<T: IComparable<T> >(p_one, p_two: T): T; static;
             end; // c_min_max

  implementation

    // -- c_min_max

    class function c_min_max.f_min<T>(p_one, p_two: T): T;
      begin
        if p_one.CompareTo(p_two)< 0
          then Result := p_one
          else Result := p_two;
      end; // f_min

    class function c_min_max.f_max<T>(p_one, p_two: T): T;
      begin
        if p_one.CompareTo(p_two)> 0
          then Result := p_one
          else Result := p_two;
      end; // f_max

    begin // u_c_min_max
    end. // u_c_min_max


